<template>
  <div>
    <div class="main-page-header">
      <div class="filter-panel">
        <search-field v-model:value="filter.name" label="Search" />
        <user-selector label="User" v-model:value="filter.userId" />
      </div>
      <icon-btn @click="showModal = true" color="#585858"
        ><path
          d="M12,2C6.477,2,2,6.477,2,12s4.477,10,10,10s10-4.477,10-10S17.523,2,12,2z M17,13h-4v4h-2v-4H7v-2h4V7h2v4h4V13z"
        ></path
      ></icon-btn>
    </div>
    <div class="statuses-wrap">
      <div
        class="status-wrap"
        v-for="status of statusesWithTasks"
        :key="status.name"
        :ref="status.name"
      >
        <div class="status-title">
          {{ status.name }}
          <span v-if="status.tasks.length">{{ status.tasks.length }}</span>
        </div>
        <div>
          <task-spacer
            :is-adjoined="
              ((!status.tasks.length ||
                (status.tasks.length === 1 &&
                  status.tasks[0].id === dragTaskId)) &&
                !hoveredTaskData.id &&
                hoveredTaskData.status === status.name) ||
              (status.tasks[0] &&
                hoveredTaskData.isTop &&
                status.tasks[0].id === hoveredTaskData.id)
            "
          />

          <template v-for="(task, i) in status.tasks" :key="task.id">
            <div
              :style="
                dragTaskId === task.id && {
                  height: `${dragParentData.height}px`,
                }
              "
            >
              <div
                :class="{ 'task-item-drag-parent': dragTaskId === task.id }"
                :style="
                  dragTaskId === task.id && {
                    top: `${dragParentData.y}px`,
                    left: `${dragParentData.x}px`,
                    width: `${dragParentData.width}px`,
                    height: `${dragParentData.height}px`,
                  }
                "
              >
                <div
                  class="task-item-wrap"
                  :class="{ 'task-item-wrap-drag': dragTaskId === task.id }"
                  :ref="task.id"
                  :style="
                    dragTaskId === task.id && {
                      top: `${moveCoords.y - startMoveCoords.y}px`,
                      left: `${moveCoords.x - startMoveCoords.x}px`,
                    }
                  "
                >
                  <task-item
                    :task="task"
                    @setEditableTask="editableTask = $event"
                    @setDragTask="setDragTask"
                  />
                </div>
              </div>
            </div>
            <task-spacer
              :is-adjoined="
                (task.id === hoveredTaskData.id && !hoveredTaskData.isTop) ||
                (status.tasks[i + 1] &&
                  hoveredTaskData.isTop &&
                  status.tasks[i + 1].id === hoveredTaskData.id)
              "
          /></template>
        </div>
      </div>
    </div>
    <update-task
      :editable-task="editableTask"
      @cancelEdit="editableTask = null"
      v-model:show="showModal"
    />
  </div>
</template>

<script>
import { mapMutations, mapState } from "vuex";
import TaskItem from "../components/TaskItem";
import { getHoveredData, initialHoveredData, statuses } from "../utils/tasks";
import UpdateTask from "../components/UpdateTask";
import TaskSpacer from "../components/TaskSpacer";
import SearchField from "../components/SearchField";
import UserSelector from "../components/UserSelector";
import moment from "moment";
import IconBtn from "../components/IconBtn";
import { dateFormat } from "../utils/time";

export default {
  name: "Home",
  components: {
    IconBtn,
    UserSelector,
    SearchField,
    TaskSpacer,
    UpdateTask,
    TaskItem,
  },
  data: () => ({
    editableTask: null,
    dragTaskId: null,
    hoveredTaskData: { ...initialHoveredData },
    moveCoords: null,
    startMoveCoords: null,
    dragParentData: null,
    filter: {
      name: "",
      userId: null,
    },
    showModal: false,
  }),
  methods: {
    ...mapMutations(["move"]),

    setDragTask({ taskId, x, y }) {
      this.startMoveCoords = { x, y };
      this.dragTaskId = taskId;
      this.dragParentData = {
        y: this.$refs[taskId].offsetTop - window.scrollY,
        x: this.$refs[taskId].offsetLeft - window.scrollX,
        width: this.$refs[taskId].offsetWidth,
        height: this.$refs[taskId].offsetHeight,
      };
      this.moveCoords = { x, y };
    },
    removeDragTask() {
      this.dragTaskId = null;
      this.dragParentData = null;
      this.startMoveCoords = null;
      this.moveCoords = null;

      this.hoveredTaskData = { ...initialHoveredData };
    },
    moveTask() {
      if (this.dragTaskId) {
        if (this.hoveredTaskData.status)
          this.move({ ...this.hoveredTaskData, dragId: this.dragTaskId });
        this.removeDragTask();
      }
    },
    mouseMove({ x, y }) {
      if (this.dragTaskId) {
        this.hoveredTaskData = getHoveredData(
          this.$refs,
          this.dragTaskId,
          this.statusesWithTasks,
          this.statusesNames
        );
        this.moveCoords = { x, y };
      }
    },
    scrollHandler(e) {
      if (this.dragTaskId) {
        this.mouseMove(e);
      }
    },
  },
  created() {
    window.addEventListener("mouseup", this.moveTask);
    window.addEventListener("blur", this.removeDragTask);
    window.addEventListener("mousemove", this.mouseMove, { capture: true });
    window.addEventListener("scroll", this.scrollHandler);
  },
  beforeUnmount() {
    window.removeEventListener("mouseup", this.moveTask);
    window.removeEventListener("blur", this.removeDragTask);
    window.removeEventListener("mousemove", this.mouseMove, { capture: true });
    window.removeEventListener("scroll", this.scrollHandler);
  },
  computed: {
    ...mapState(["tasks", "users"]),
    statusesNames() {
      return Object.values(statuses);
    },
    statusesWithTasks() {
      return this.statusesNames.map((statusName) => ({
        name: statusName,
        tasks: this.prepTasks.filter(({ status }) => status === statusName),
      }));
    },
    filteredTasks() {
      const { name, userId } = this.filter;
      return this.tasks.filter(
        (t) =>
          (name.length
            ? t.name.toLowerCase().indexOf(name.toLowerCase()) !== -1
            : true) && (userId !== null ? t.userId === userId : true)
      );
    },
    prepTasks() {
      return this.filteredTasks.map((task) => ({
        ...task,
        user: this.users.find(({ id }) => id === task.userId),
        daysLeft: moment(task.deadline, dateFormat).diff(moment(), "days") + 1,
      }));
    },
  },
};
</script>

<style scoped>
.statuses-wrap {
  display: grid;
  grid-template-columns: 1fr;
  grid-column-gap: 1rem;
  padding: 2rem;
  margin-bottom: 2rem;
  overflow: visible;
  user-select: none;
  background-color: white;
  box-shadow: 0 0 12px 0 rgba(34, 60, 80, 0.4);
}
.status-wrap {
  padding-bottom: 2rem;
  background-color: white;
}
.task-item-wrap {
  position: relative;
  box-shadow: 0 0 5px 0 rgba(34, 60, 80, 0.4);
  transition: box-shadow 0.3s;
  border-radius: 2px;
  cursor: pointer;
}
.task-item-wrap-drag {
  background-color: rgba(255, 255, 255, 0.5);
  box-shadow: 0 0 5px 0 #4181ff;
}

.task-item-drag-parent {
  position: fixed;
  z-index: 1000;
}
.status-title {
  font-size: 24px;
  color: #585858;
  margin-bottom: 1rem;
}

.filter-panel {
  display: grid;
  grid-template-columns: 1fr;
  width: 480px;
  max-width: calc(100% - 4rem);
  gap: 1rem;
}

.main-page-header {
  display: flex;
  justify-content: space-between;
  align-items: flex-end;
  padding: 2rem;
}

@media (min-width: 768px) {
  .filter-panel {
    grid-template-columns: 1fr 1fr;
  }
}
@media (min-width: 1024px) {
  .statuses-wrap {
    grid-template-columns: repeat(4, 1fr);
  }
  .status-title {
    margin-bottom: 2rem;
  }
}
@media (min-width: 1280px) {
  .statuses-wrap {
    grid-column-gap: 3rem;
  }
}
</style>
